# coding: utf-8
import sys
from tkinter import *
from tkinter import messagebox
import time
def array2(N1,N2):
    return [[0 for _1 in range(N2)]for _2 in range(N1)]
#■基本データ
dTab = array2(8,8)                          #マス目データ
Eval =((200,  6, 70, 30, 30, 70,  6,200),   #評価関数テーブル
       (  6,  5,  7,  6,  6,  7,  5,  6),
       ( 70,  7, 40, 30, 30, 40,  7, 70),
       ( 30,  6, 30,  1,  1, 30,  6, 30),
       ( 30,  6, 30,  1,  1, 30,  6, 30),
       ( 70,  7, 40, 30, 30, 40,  7, 70),
       (  6,  5,  7,  6,  6,  7,  5,  6),
       (200,  6, 70, 30, 30, 70,  6,200))
procTable= ( (-1, -1), (-1, 0), (-1, 1),    # チェック方向
             ( 0, -1),          ( 0, 1),
             ( 1, -1), ( 1, 0), ( 1, 1))
#■最初の石の位置
def initDtab():
    for i in range(8):
        for j in range(8): dTab[i][j]=0
    dTab[3][3]=1; dTab[4][4]=1;  dTab[4][3]=2; dTab[3][4]=2
#■範囲内チェック
def inRange(x,y):
    if x>=0 and x<=7 and y>=0 and y<=7: return True
    return False
#■石を置いたとき裏返す石の数をカウント。なければ -1 を返却する。
def numberCount(ii, jj, TB, i):
    if dTab[ii][jj] != 0: return -1; #既に石が配置されていれば置けない。
    RB = 3 - TB; ip = procTable[i][0]; jp = procTable[i][1] #チェック方向設定
    IIP = ii + ip; JJP = jj + jp        # 1 個先の配列添字設定。
    if not inRange(JJP,IIP) : return -1 # 1 個先が範囲外なら置けない。
    if dTab[IIP][JJP] != RB: return -1  # 1 個先が対戦者の石でないとき
    numStone = 1                        # 置けない(自分の石/石がない)。
    while dTab[IIP][JJP] == RB:         # 対戦者の石が続くときカウント。
        IIP += ip; JJP += jp
        if not inRange(JJP,IIP): return -1
        numStone+=1
    if dTab[IIP][JJP] == TB: return numStone -1 # 対戦者の石が途切れた箇所が
    else: return -1;                            # 自分の石のとき石を置ける。
#■セル(ii, jj)に石を置くことができるかを判定。                                               
def canPlace(ii, jj, TB):
    for i in range(8):
        if numberCount(ii, jj, TB, i) >=0: return True
    return False
#■石を置く場所があるかを判定。
def canPlaceAny(TB):
    for ii in range(8):
        for jj in range(8):
            if canPlace(ii, jj, TB):return True
    return False
#■ゲーム終了判定
def judgeEnd():# 終了判定。
    if canPlaceAny(1): return False
    if canPlaceAny(2): return False
    return True;
#■石の裏返し
def replacePlane(ii, jj, TB): 
    Temp=array2(8,8) #石の状態を作業領域に移して
    for i in range(8):
        for j in range(8):Temp[i][j]=dTab[i][j];
    for i in range(8): #判定して置き換えた結果は作業領域に設定する
        num = numberCount(ii, jj, TB, i);ip = ii; jp = jj
        di = procTable[i][0];dj = procTable[i][1]
        if (num > 0):  #作業領域上で石を裏返す
            for j in range(num+1): Temp[ip][jp] = TB;ip += di; jp += dj
    for i in range(8): #最後、盤面に繁栄する
        for j in range(8): dTab[i][j]=Temp[i][j]
#■コンピュータ側判定処理
def computer():# コンピュータ側判定処理
    if (judgeEnd()) : return # ゲーム終了時なら処理なし
    TB = 2-val.get()         # 打ち手が先攻ならコンピュータ側は後攻
    MaxPr = -1; MaxI = -1; MaxJ = -1; MaxNum = 0
    for ii in range(8):
        for  jj in range(8):
            numTotal = 0
            for i in range(8): # セル(ii, jj)に置いたとき裏返す石の数カウント
                num = numberCount(ii, jj, TB, i)
                if num > 0: numTotal += num
            if numTotal > 0 and( MaxPr < 0 or MaxPr < Eval[ii][jj] or
                                (MaxPr == Eval[ii][jj]and MaxNum < numTotal)) :# 同一優先順位のとき
                # 裏返すことができる中で最優先順位，同一優先順位のとき裏返す石が多い方
                MaxPr = Eval[ii][jj]; MaxI = ii; MaxJ = jj; MaxNum = numTotal
    if MaxPr < 0:   messagebox.showinfo("コンピュータ側","打つ場所がありません。パスします");
    else: replacePlane(MaxI, MaxJ, TB);    #  石を裏返す
    display()
#■対戦者の処理
def person(ip, jp):
    if (dTab[ip][jp] != 0): return  # 既に石が置いてあるところは無視
    TB = val.get()+1          # 対戦者の石の種類
    if canPlace(ip, jp, TB):  # 石を置くことができるとき，裏返し処理
        replacePlane(ip, jp, TB); display(); computer(); # コンピュータ側処理
    else : messagebox.showinfo("注意", "そこには打てません。")
    if judgeEnd():            # ゲーム終了の場合
        TB1 = 0; TB2 = 0      # 両者の石をカウントする
        for ii in range(8):
            for jj in range(8):
                if   dTab[ii][jj] == 1: TB1+=1
                elif dTab[ii][jj] == 2: TB2+=1
        if TB1 == TB2: messagebox.showinfo("勝敗","引き分けです。")  # 石の数で勝負判定
        elif ((TB1 > TB2) and (val.get()==0)) or ((TB2 > TB1) and (val.get()==1)):
            messagebox.showinfo("勝敗","貴方の勝ちです。黒 = %d, 白 = %d " % (TB1, TB2))
        else : messagebox.showinfo("勝敗","私の勝ちです。黒 = %d, 白 = %d " % (TB1, TB2))
    display()
#■石を表示
def dspStone(i, j, B, R):
    X = j * 50 + 15; X1 = X + 1; Y = i * 50 + 15; Y1 = Y + 1
    canvas.create_oval(X1, Y1, X1 + R, Y1 + R, fill='gray', outline= 'gray', tag='stone')
    canvas.create_oval(X, Y, X + R, Y + R, fill=B, outline= 'gray', tag='stone')
    
#■画面表示
def display():
    canvas.delete('stone')
    for i in range(8):
        for j in range(8):
            if   dTab[i][j] == 1: dspStone(i,j, 'black',40)
            elif dTab[i][j] == 2: dspStone(i,j, 'white',38)
    root.update()
#■初期設定
def initialize():
    initDtab(); display()
#■ゲーム開始
def startProc():
    initialize()
    if val.get()==1: computer()
#■ 石を置ける場所があるかどうか判定し、置ける場合はパス解消。ない場合にパス。
def passProc(): 
    TB = 2;
    if val.get==0: TB = 1
    if canPlaceAny(TB): messagebox.showinfo("ルール","置ける場所があります。パスできません")
    else: computer()
#■左ボタンイベント
def leftMouseDown(event):#ダウン
    x=int((event.x-10)/50); y=int((event.y-10)/50)
    if inRange(x,y): person(y,x) #　元プログラムがExcel VBAなので行方向が最初に来ている
    display()
#■ウィンドウが閉じられるときの処理
def exitProc():
    if messagebox.askokcancel("終了","終了してもよろしいですか?"):
        root.destroy();  sys.exit()
#■メイン処理   
root=Tk()
root.title("Othello: 先攻・後攻を選択して開始ボタンをクリックして下さい")
root.geometry("420x460")
canvas=Canvas(root,width=420,height=420,highlightthickness=0)
canvas.pack()
#初期画面の用意
canvas.create_rectangle(10,10,410,410, fill='green')
ii=10
for i in range(1,8):
    ii+=50
    canvas.create_line(10, ii, 410, ii, fill='#FFFFAA')
    canvas.create_line(ii, 10, ii, 410, fill='#FFFFAA')
canvas.create_rectangle(10,10,410,410, fill='', outline='#5555FF', width=3)
#コントロール等
val=IntVar(); val.set(0)
r0=Radiobutton(text='先攻',variable=val, value=0)
r1=Radiobutton(text='後攻', variable=val, value=1)
r0.place(x=10,y=415); r1.place(x=100,y=415)
canvas.bind("<Button-1>",leftMouseDown)
btn1 = Button(root, text='開始', height=1, command=startProc,font=('ＭＳ ゴシック',10,'normal'))
btn2 = Button(root, text='パス', height=1, command=passProc,font=('ＭＳ ゴシック',10,'normal'))
btn3 = Button(root, text='終了', height=1, command=exitProc,font=('ＭＳ ゴシック',10,'normal'))
btn1.place(x = 200, y = 415)
btn2.place(x = 250, y = 415)
btn3.place(x = 350, y = 415)
#■メインループ
initialize()
root.protocol("WM_DELETE_WINDOW",exitProc) #ウィンドウが閉じられたときexitProcを呼び出す。
root.mainloop()




